'use strict';

var path = require('path');
var isBuiltinModule = require('is-builtin-module');
var options = require('@rollup-extras/utils/options');
var logger = require('@rollup-extras/utils/logger');
var packageDirectory = require('pkg-dir');

const factories = { logger };
function index (options$1 = {}) {
    const { pluginName, external, logger, verbose } = options.getOptionsObject(options$1, {
        pluginName: '@rollup-extras/plugin-externals',
        verbose: false
    }, factories);
    const logLevel = verbose ? 1 /* LogLevel.info */ : 0 /* LogLevel.verbose */;
    let pkgDir = false;
    return {
        name: pluginName,
        async resolveId(id, importer) {
            if (pkgDir === false) {
                pkgDir = (await packageDirectory()) ?? '.';
            }
            const importingFileName = path.resolve(path.dirname(importer || ''), id);
            let isExternal = id.includes('node_modules') || isBuiltinModule(id) || path.relative(pkgDir, importingFileName).startsWith('..');
            if (external) {
                isExternal = external(id, isExternal, importer);
            }
            logger(`'${id}' is ${isExternal ? '' : 'not '}external`, logLevel);
            return isExternal ? false : null;
        }
    };
}

module.exports = index;
